unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, MMSystem, JPEG, StdCtrls, Menus, Buttons, MPlayer, ComCtrls;

type
  TMainform = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    menuAdicionar: TMenuItem;
    BtnPlay: TSpeedButton;
    BtnPause: TSpeedButton;
    MediaPlayer1: TMediaPlayer;
    BtnStop: TSpeedButton;
    BtnBack: TSpeedButton;
    BtnNext: TSpeedButton;
    Timer1: TTimer;
    BtnSair: TSpeedButton;
    menuRemover: TMenuItem;
    TrackBar1: TTrackBar;
    Image1: TImage;
    ProgressBar1: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure menuAdicionarClick(Sender: TObject);
    procedure BtnPlayClick(Sender: TObject);
    procedure BtnPauseClick(Sender: TObject);
    procedure BtnStopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BtnSairClick(Sender: TObject);
    procedure menuRemoverClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure MudaFaixa(Valor : Integer);
    procedure MudaVolume;
    procedure TestaVolume;
    procedure BtnNextClick(Sender: TObject);
    procedure BtnBackClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Panel1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mainform: TMainform;
  Lista : TStringList; //varivel que armazenar a sequncia das msicas
  PLAYING : Boolean = FALSE; //guarda estado do tocador; padro  false
  Cont : Integer = 0; //conta em qual faixa est

implementation

{$R *.dfm}

procedure TMainform.FormCreate(Sender: TObject);
var i : Integer;
begin
 //torna o alinhamento do Painel 3 "alClient", para preencher
 //toda a rea disponvel do form
 Panel3.Align := alClient;

 //cria a varivel (que guardar a Playlist) na memria
 Lista := TSTringList.Create;

 //se j existe uma playlist, carrega-a
 if FileExists(ExtractFilePath(ParamStr(0))+'Lista.txt') then begin
  Lista.LoadFromFile(ExtractFilePath(ParamStr(0))+'Lista.txt');
  { Para mostrar msicas no painel, remove caminho de diretrios,
    extraindo apenas os nomes dos arquivos }
  for i:=0 to Lista.Count-1 do
    ListBox1.Items.Add(ExtractFileName(Lista.Strings[i]));
 end;

 //obtm volume para ajustar TrackBar1
 TestaVolume;

 //carrega imagem
 if FileExists(ExtractFilePath(ParamStr(0))+'MPj0431323000010.jpg') then
  Image1.Picture.LoadFromFile(ExtractFilePath(ParamStr(0))+'MPj0431323000010.jpg');

end;

procedure TMainform.FormActivate(Sender: TObject);
begin
 //maximiza o formulrio aps ele ser criado
 WindowState := wsMaximized;
end;

procedure TMainform.menuAdicionarClick(Sender: TObject);
begin
 //Chama a caixa de dilogo de abrir arquivos
 //para ir montando a PlayList

 if OpenDialog1.Execute then  begin
  Lista.Add(OpenDialog1.FileName);
  ListBox1.Items.Add(ExtractFileName(OpenDialog1.FileName));
 end;
end;

procedure TMainform.BtnPlayClick(Sender: TObject);
begin

 { se j estava tocando, no aciona PLAY de novo e, sim,
   RESUME, para prosseguir do ponto onde parou }
 if PLAYING then MediaPlayer1.Resume
  else begin
   { vai iniciar uma faixa, verifica qual
      atravs da varivel Cont, atribui ao MediaPlayer
     e atribui tambm  ListBox }
   MediaPlayer1.Close;  
   MediaPlayer1.FileName := Lista.Strings[Cont];
   ListBox1.Selected[Cont] := True;
   MediaPlayer1.Open;
   MediaPlayer1.Play;
   Timer1.Enabled := True;//habilita timer
  end;
 PLAYING := True;  
end;

procedure TMainform.BtnPauseClick(Sender: TObject);
begin
 MediaPlayer1.Pause;
end;

procedure TMainform.BtnStopClick(Sender: TObject);
begin
 if PLAYING then begin
  MediaPlayer1.Stop;
  PLAYING := FALSE;
  Timer1.Enabled := False; //pra o timer
 end; 
end;

procedure TMainform.Timer1Timer(Sender: TObject);
begin
 { Verifica o andamento da msica do MediaPlayer;
   se posio da faixa = largura, ento
   muda para a faixa seguinte }

  if MediaPlayer1.Position = MediaPlayer1.Length then
   begin
    with MediaPlayer1 do begin
     Cont := Cont + 1;
     if Cont > Lista.Count-1 then
      Cont := 0;
     Close ;
     if FileExists(Lista.Strings[Cont]) then begin
      TimeFormat :=  tfHMS;
      FileName := Lista.Strings[Cont];
      Open ;
      Play;
     end
      else
       Cont := Cont + 1;
    end; //with MediaPlayer
   end; //if MediaPlayer

  ListBox1.Selected[Cont];

 if PLAYING then begin
  ProgressBar1.Max := MediaPlayer1.Length;
  ProgressBar1.Position := MediaPlayer1.Position;
 end;
end;

procedure TMainform.BtnSairClick(Sender: TObject);
begin
 { ao fechar o form, salva a Playlist }
 if application.MessageBox('Sair do aplicativo?',pchar(Caption),36)=IDYES then begin
  Lista.SaveToFile(ExtractFilePath(ParamStr(0))+'Lista.txt');
  Close;
 end;
end;

procedure TMainform.menuRemoverClick(Sender: TObject);
begin
 if application.messagebox(pchar('Remover faixa '+ListBox1.Items.strings[ListBox1.ItemIndex]+'?'),pchar(Caption),36)=IDYES then begin
  BtnStopClick(self);
  Lista.Delete(ListBox1.ItemIndex);
  ListBox1.DeleteSelected;
  if Cont > 0 then
   Cont := Cont - 1;
 end; 
end;

procedure TMainform.ListBox1DblClick(Sender: TObject);
begin
 if PLAYING then
  BtnStopClick(self);//aciona boto de stop

 Cont := ListBox1.ItemIndex;
 Lista.Strings[Cont];
 BtnPlayClick(self);
 
end;

procedure TMainform.MudaFaixa(Valor : Integer);
begin
 { "Valor" guarda o sinal: 1 para prxima faixa
   e -1 para faixa anterior }

 if (Valor <> -1) and (Valor <> 1) then exit;

 if PLAYING then begin
  MediaPlayer1.Stop;
  Timer1.Enabled := False;
  PLAYING := FALSE;
 end;

 Cont := Cont + Valor;

 //testa se no passou da ltima ou se no se est tentando
 //voltar para antes da primeira msica
 if (Cont > (ListBox1.Items.Count -1)) then
  Cont := 0
  else
   if (Cont < 0) then
    Cont := (ListBox1.Items.Count -1)  ;

 MediaPlayer1.Close;

 MediaPlayer1.FileName := Lista.Strings[Cont];
 ListBox1.Selected[Cont]:=true;
 MediaPlayer1.Open;
 MediaPlayer1.Play;

 Timer1.Enabled := True;
 PLAYING := True;
end;

procedure TMainform.BtnNextClick(Sender: TObject);
begin
 MudaFaixa(1);
end;

procedure TMainform.BtnBackClick(Sender: TObject);
begin
 MudaFaixa(-1);
end;

procedure TMainform.MudaVolume;
var
  WaveCaps : TWaveOutCaps;
  VolDir, VolEsq : Word;
begin
// acha volume, a partir da posio da Trackbar
  VolEsq := Trunc((TrackBar1.Position-100) / 100 * $FFFF);
  VolDir := Trunc((TrackBar1.Position-100) / 100 * $FFFF);

// testa se suporta alterao de volume
  if waveOutGetDevCaps(WAVE_MAPPER, @WaveCaps, sizeof(TWaveOutCaps)) = MMSYSERR_NOERROR then
    if (WaveCaps.dwSupport and WAVECAPS_VOLUME) <> 0 then
// configura novo volume
      WaveOutSetVolume(Integer(WAVE_MAPPER), MakeLong(VolEsq,VolDir));

end;

procedure TMainform.TestaVolume;
var
  WaveCaps : TWaveOutCaps;
  Volume : DWord;
begin

// testa se suporta alterao de volume
  if waveOutGetDevCaps(WAVE_MAPPER, @WaveCaps, sizeof(TWaveOutCaps)) = MMSYSERR_NOERROR then
    if (WaveCaps.dwSupport and WAVECAPS_VOLUME) <> 0 then begin
// obtm volume
      WaveOutGetVolume(Integer(WAVE_MAPPER), @Volume);
// quebra o Cardinal e configura posio de Trackbars
    with TrackBar1 do
      Position := 100 - Trunc(LoWord(Volume) / $FFFF * 100);
    end;
end;

procedure TMainform.TrackBar1Change(Sender: TObject);
begin
 MudaVolume;
end;

procedure TMainform.Panel1DblClick(Sender: TObject);
begin
 WindowState := wsMinimized;
end;

end.
